package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type UpdateNetworkSegmentRangesLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewUpdateNetworkSegmentRangesLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdateNetworkSegmentRangesLogic {
	return &UpdateNetworkSegmentRangesLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UpdateNetworkSegmentRangesLogic) UpdateNetworkSegmentRanges(req *types.UpdateNetworkSegmentRangesReq) (resp *types.UpdateNetworkSegmentRangesResp, err error) {
	// todo: add your logic here and delete this line
	UpdateNetworkSegmentRangesReq := &openstack.UpdateNetworkSegmentRangesReq{}
	err = copier.CopyWithOption(UpdateNetworkSegmentRangesReq, req, copier.Option{Converters: utils.Converters})
	UpdateNetworkSegmentRangesResp, err := l.svcCtx.OpenstackRpc.UpdateNetworkSegmentRanges(l.ctx, UpdateNetworkSegmentRangesReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&UpdateNetworkSegmentRangesResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &UpdateNetworkSegmentRangesResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
